package dev.peerat.framework;

import java.io.IOException;
import java.lang.reflect.Method;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jose4j.jwt.consumer.InvalidJwtException;

public class TomcatServlet extends HttpServlet{
	
	private static Router<?> router;
	
	static void setRouter(Router<?> router){
		TomcatServlet.router = router;
	}
	
	@Override
	public void init(ServletConfig config) throws ServletException{
		try{
			String value = config.getInitParameter("router");
			Class<?> clazz = Class.forName(value);
			for(Method method : clazz.getDeclaredMethods()){
				if(method.getName().equals("main")) method.invoke(null, new Object[] {null});
			}
		}catch(Exception ex){
			throw new RuntimeException(ex);
		}
	}
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		Context context = null;
		HttpReader reader = null;
		HttpWriter writer = null;
		try{
			reader = new TomcatHttpReader(request);
			writer = new TomcatHttpWriter(response);
			context = new Context(RequestType.GET, request.getPathInfo(), isLogin(router, RequestType.GET, reader, writer), writer);	
			router.exec(context, reader, writer);
			writer.flush();
			writer.close();
		}catch(InvalidJwtException e){
		}catch(Exception e){
			if(context != null && context.getResponseCode() == 0){
				try{
					context.response(500);
					writer.flush();
					writer.close();
				}catch(Exception ex){}
			}
		}
		if(context != null) router.getLogger().setValue(context);
	}
	
	private User isLogin(Router<?> router, RequestType type, HttpReader reader, HttpWriter writer) throws Exception{
		String auth = reader.getHeader("Authorization");
		if(auth == null) return null;
		auth = auth.substring(7);
		try{
			return router.getUser(auth);
		}catch(InvalidJwtException e){
			try{
				writer.response(401, router.getDefaultHeaders(type));
				writer.flush();
				writer.close();
			}catch(Exception ex){}
			throw e;
		}
	}
	
}
